package com.objis.springmvcdemo.dao;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.jdbc.core.RowMapper;
import org.springframework.jdbc.core.support.JdbcDaoSupport;

import com.objis.springmvcdemo.dao.IEmployeDao;
import com.objis.springmvcdemo.domaine.Employe;


public class JdbcEmployeDaoSupport extends JdbcDaoSupport implements IEmployeDao{

	public void saveEmploye(Employe employe) {

		final String EMPLOYE_INSERT = "insert into employe (id,login, password, prenom, nom, email, role) "
				+ "values (?,?,?,?,?,?,?)";

		/*
		 * On rcupre et on utilisera directement le jdbcTemplate
		 */
		getJdbcTemplate().update(
				EMPLOYE_INSERT,
				new Object[] { employe.getId(),employe.getLogin(),employe.getPassword(), 
						employe.getPrenom(),employe.getNom(), employe.getEmail(),employe.getRole() });
	}

	//@SuppressWarnings("unchecked")
	public List<Employe> getAllEmployes() {
		final String ALL_EMPLOYE = "select * from employe";
		// TODO rcupration de tous les employs
		
		List<Employe> employes = new ArrayList<Employe>();
		
		Employe emp1 = new Employe(1, "doug", "pwd", "Douglas", "MBIANDOU", "d@objis.com", "formateur");
		Employe emp2 = new Employe(2, "nassur", "pwd", "Nassur", "MHOUMADI", "n@objis.com", "formateur");
		
		//List<Map<String, Object>> allEmployes = getJdbcTemplate().queryForList(ALL_EMPLOYE);
		//List<Employe> allEmployes = getJdbcTemplate().queryForList(ALL_EMPLOYE);
		
		employes.add(emp1);
		employes.add(emp2);
		
		return employes;
	}

	public Employe getEmployeById(int id) {
		// TODO recupration d'un employ en fonction de son Id
		
		String sql = "select id, nom, prenom from employe where id = ?";

		// Mapping d'un enregistrement vers un ResultSet
		RowMapper mapper = new RowMapper() {
			public Object mapRow(ResultSet rs, int rowNum) throws SQLException {
				Employe employe = new Employe();
				employe.setId((int) rs.getLong("id"));
				employe.setNom(rs.getString("nom"));
				employe.setPrenom(rs.getString("prenom"));
				return employe;
			}

		};

		return (Employe) getJdbcTemplate().queryForObject(sql, new Object[] { Long
				.valueOf(id) }, mapper);

	
	}

	public Employe getEmployeByLogin(String login) {
		// TODO recupration d'un employ en fonction de son Id
		
				String sql = "select login, nom, prenom, email from employe where login = ?";

				// Mapping d'un enregistrement vers un ResultSet
				RowMapper mapper = new RowMapper() {
					public Object mapRow(ResultSet rs, int rowNum) throws SQLException {
						Employe employe = new Employe();
						employe.setLogin((String) rs.getString("login"));
						employe.setNom(rs.getString("nom"));
						employe.setPrenom(rs.getString("prenom"));
						employe.setEmail(rs.getString("email"));
						return employe;
					}

				};

				return (Employe) getJdbcTemplate().queryForObject(sql, new Object[] { String
						.valueOf(login) }, mapper);

			
	}

	public int getEmployesCount() {
		final String EMPLOYE_COUNT = "select count(*) from employe";

	/*
	 * On rcupre et on utilisera directement le jdbcTemplate
	 */
		
	 int i = getJdbcTemplate().queryForInt(EMPLOYE_COUNT);
	
		return i;
	}
}
